<template>
  <div class="m-4">
    <b-overlay :show="show" rounded="sm">
      <router-link :to="{ name: 'car'}">
              <b-button variant="outline-primary" size="sm" class="m-2">
                Add Car
              </b-button>
            </router-link>
    <b-card>
      <div slot="header">
        <strong>Cars</strong>
      </div>
      <b-table responsive striped hover :items="cars_list" :fields="fields">
        <template v-slot:cell(currentLocation)="row">
          {{row.item.currentLocation.lat}} - {{row.item.currentLocation.lng}}
        </template>
        <template v-slot:cell(actions)="row">
            <router-link :to="{ name: 'car', params: { id: row.item.vin } }">
              <b-button variant="outline-primary" size="sm" class="m-1">
                Edit
              </b-button>
            </router-link>
            <b-button @click="deleteCar(row.item.vin)" variant="danger" size="sm" class="mr-1">
              Delete
            </b-button>
        </template>
      </b-table>
    </b-card>
    </b-overlay>
  </div>
</template>

<script>
export default {
  data() {
    return {
      cars_list: [],
      fields: [
        { key: "vin"},
        { key: "license"},
        { key: "vehicleBrand"},
        { key: "vehicleModel"},
        { key: "deviceID"},
        { key: "deviceBrand"},
        { key: "deviceModel"},
        { key: "lastMaintenanceOdo"},
        { key: "lastMaintenanceDate"},
        { key: "status"},
        { key: "currentLocation"},
        { key: "currentOdo"},
        { key: "notes"},
        { key: "actions"},
      ],
      show: false
    };
  },
  async created() {
    await this.fetchAll();
  },
  computed: {},
  methods: {
    async fetchAll() {
      this.show = true
      await this.axios
        .get(
          "https://d16c9f74-b46c-415e-bb10-9d5169cc5625.mock.pstmn.io/cars/all"
        )
        .then((response) => {
          this.cars_list = response.data;
        }).catch(error => window.alert(error));
      this.show = false
    },
    async deleteCar(id) {
      this.show = true
      await this.axios
        .delete(
          `https://d16c9f74-b46c-415e-bb10-9d5169cc5625.mock.pstmn.io/cars/vin=${id}`
        )
        .then((response) => {
          console.log(response)
          window.alert("delete success")
        }).catch(error => window.alert(error));
      this.show = false
    }
  },
};
</script>

<style lang="scss">
table {
  font-size: 14px;
}
</style>